## Script (Python) "render_field"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=node, info, num_cols
##title=
##
request = context.REQUEST
model = request.model

if context.is_field_simple(node):
    # find p first (FIXME: inefficient)
    for child in node.childNodes:
        if child.nodeType == node.ELEMENT_NODE:
            break
    node = child
    if len(node.childNodes) == 0:
        return '<td class="custom-row-heading align-%s" colspan="%i">&nbsp;</td>' % (info['align'], 
            num_cols)
    if (len(node.childNodes) == 1 and hasattr(node.childNodes[0], 'data') and 
            len(node.childNodes[0].data.strip()) == 0):
        return '<td class="custom-row-heading align-%s" colspan="%i">&nbsp;</td>' % (info['align'], 
            num_cols)
    else:
        editorsupport = model.service_editorsupport
        supp = editorsupport.getMixedContentSupport(model, node)
        view_type = (context.id == 'mode_view') and 'public' or 'edit'
        return '<td class="custom-row-heading align-%s" colspan="%i">%s</td>' % (
            info['align'], num_cols, 
            supp.renderHTML(view_type=view_type))
else:
    context.service_editor.setViewer('service_sub_previewer')
    content = context.service_editor.renderView(node)
    return '<td class="custom-row-heading align-%s" colspan="%i">%s</td>' % (info['align'],
        num_cols, content)
